#!/usr/bin/env bash
set -e

efi_mnt="/boot/efi"
boot_order_file="${efi_mnt}/EFI/BOOT/HwBootOrder.ini"

next_boot=$1
if [[ -z $next_boot ]]; then
    echo "Usage: $0 next_boot"  >> /opt/ple-mode-check.log
    echo "Arguments:"  >> /opt/ple-mode-check.log
    echo "next_boot    choices:hd, pxe"  >> /opt/ple-mode-check.log
    exit 1
fi

if [[ $(id -u) -ne 0 ]]; then
    echo "Root permission required"  >> /opt/ple-mode-check.log
    exit 1
fi
#efi_readonly=false
#if mountpoint -q $efi_mnt && [[ ! -w $efi_mnt ]]; then
#    echo "$efi_mnt is readonly"
#    efi_readonly=true
#    mount -o remount,rw $efi_mnt
#fi


case $next_boot in
    hd|HD)
          echo HwBootOrder=0123 > ${boot_order_file}
	  echo "set boot to hdd " >> /opt/ple-mode-check.log
	  order_result=$(cat ${boot_order_file})
	  if [ "x$order_result" == "xHwBootOrder=0123" ];then
		  echo "check set boot to hdd success " >> /opt/ple-mode-check.log
	  else

		  echo "check set boot to hdd failed " >> /opt/ple-mode-check.log
		  echo "could not set boot mode to hd..." >> /boot/efi/SI_FAILED
	  fi
          ;;
    pxe|PXE)
          echo HwBootOrder=2013 > ${boot_order_file}
	  echo "set boot to pxe " >> /opt/ple-mode-check.log
          order_result=$(cat ${boot_order_file})
          if [ "x$order_result" == "xHwBootOrder=2013" ];then
                  echo "check set boot to pxe success " >> /opt/ple-mode-check.log
          else

                  echo "check set boot to pxe failed " >> /opt/ple-mode-check.log
                  echo "could not set boot mode to pxe..." >> /boot/efi/SI_FAILED
          fi
          ;;
    *)
          echo "Error argument $next_boot, only hd or pxe is supported" >> /opt/ple-mode-check.log
          exit 1
esac

#if $efi_readonly; then
#    echo "restore $efi_mnt to readonly"
#    mount -o remount,ro $efi_mnt
#fi

echo "set next order to $next_boot is done"   >> /opt/ple-mode-check.log
echo "print the content of ${boot_order_file}" >> /opt/ple-mode-check.log
cat ${boot_order_file} >> /opt/ple-mode-check.log
